#include <stdio.h>
#include <libplayerc/playerc.h>

int main(int argc, const char **argv)
{
  playerc_client_t *client;
  playerc_position2d_t *position2d;
  playerc_laser_t *laser;
  playerc_sonar_t *sonar;

  int i;

// Conecta ao servidor
  client = playerc_client_create(NULL, "localhost", 6665);
  if (playerc_client_connect(client) != 0)
    return -1;

// Conecta ao position (comando e odometria)
  position2d = playerc_position2d_create(client, 1);
  if (playerc_position2d_subscribe(position2d, PLAYERC_OPEN_MODE) != 0)  return -1;

// Conecta ao laser
  laser = playerc_laser_create(client, 0);
  if (playerc_laser_subscribe(laser, PLAYERC_OPEN_MODE))
    return -1;

// Conecta ao sonar
//  sonar = playerc_sonar_create(client, 0);
//  if (playerc_sonar_subscribe(sonar, PLAYERC_OPEN_MODE))
//    return -1;

// Configura parametros
if (playerc_client_datamode (client, PLAYERC_DATAMODE_PULL) != 0)
{
  fprintf(stderr, "error: %s\n", playerc_error_str());
  return -1;
}

// Configura parametros
if (playerc_client_set_replace_rule (client, -1, -1, PLAYER_MSGTYPE_DATA, -1, 1) != 0)
{
  fprintf(stderr, "error: %s\n", playerc_error_str());
  return -1;
}

   // Ativa os motores do robo
   playerc_position2d_enable(position2d, 1);

   //Comando para o robô se mover para frente a 0,2m/s e depois rotacionar a 0.4rad/s
   playerc_position2d_set_cmd_vel(position2d, 0.2, 0.0, 0.0, 1);

   playerc_client_read(client);
   playerc_client_read(client);
   playerc_client_read(client);
   playerc_client_read(client);
   playerc_client_read(client);

 // Mostra a posiçao do robô
 for(i = 0; i < 100; i++)
 {
   //Recebe dados do servidor
   playerc_client_read(client);
   //Mostra a posição do robô
   printf("position : %f %f %f\n", position2d->px, position2d->py, position2d->pa);
 }

  //Comando para o robô rotacionar a 0.4rad/s (giro para esquerda, negativo p/direita)
  playerc_position2d_set_cmd_vel(position2d, 0.0, 0.0, 0.4, 1);

 // Mostra a posiçao do robô
 for(i = 0; i < 100; i++)
 {
   //Recebe dados do servidor
   playerc_client_read(client);
   //Mostra a posição do robô
   printf("position : %f %f %f\n", position2d->px, position2d->py, position2d->pa);
 }

	
  playerc_position2d_set_cmd_vel(position2d, 0.0, 0.0, 0.0, 1);

  playerc_laser_unsubscribe(laser);
  playerc_laser_destroy(laser);
  playerc_position2d_unsubscribe(position2d);
  playerc_position2d_destroy(position2d);
  playerc_client_disconnect(client);
  playerc_client_destroy(client);

  return 0;
}
